import pyglet
import cocos
from cocos.actions import *

from cbl import scene
from cbl import actors

from cbl import docks_sneaking

class Scene(scene.SceneLayer):
    '''Protagonist has no gun but is following the bad guy anyway.
    '''
    map_file = 'apt_ext_chase.svg'

    def open_scene(self):
        # add the player
        self.actors['player'] = actors.Player()
        self.action_layer.add(self.actors['player'])

        a = self.add_actor('npc', actors.ShooterNPC, 'target_npc_start')
        a.sprite.do(Delay(0.2) +
            MoveBy((20, 0), duration=.2) + 
            Delay(0.1) +
            MoveBy((10, 20), duration=.2) + 
            Delay(0.1) +
            MoveBy((30, 0), duration=.2) + 
            FadeOut(duration=0.01)
        )

        van = pyglet.resource.image('fish_van.png')
        pos = self.get_box('van_position').bottomleft
        self.van = cocos.sprite.Sprite(van, pos, anchor=(0, 0))
        self.action_layer.add(self.van)

        self.van.do(Delay(1.5) + 
            MoveBy((200, 0))
        )

        self.do(
            Delay(2) +
            CallFunc(self.say, 'player',
                "Bruno's Fish... that's down at the docks")
        )

    def trigger_door(self):
        self.enable_action('Run away', self.leave)

    def untrigger_door(self):
        self.disable_action()

    def leave(self):
        self.disable_action()
        self.you_failed()

    def trigger_exit(self):
        self.enable_action('Chase them', self.chase)

    def untrigger_exit(self):
        self.disable_action()

    def chase(self):
        self.new_scene(docks_sneaking.Scene())
