import random
import cocos
from cocos.actions import *

from cbl import scene
from cbl import actors

from cbl import hideout_sneaking

class Scene(scene.SceneLayer):
    map_file = 'docks_sneaking.svg'
    focus_player = True

    def open_scene(self):
        a = self.actors['player'] = actors.Player()
        self.action_layer.add(a)
        r = self.get_box('target_player_start')
        self.scroller.set_focus(*r.midbottom)

    def trigger_front_door(self):
        self.enable_action('Open Door', self.front_door)
    def untrigger_front_door(self):
        self.disable_action()

    def front_door(self):
        self.triggers_disabled['trigger_front_door'] = True
        self.remove_blocker('door_blocker')
        self.disable_action()
        for n, path in enumerate(self.triggers.paths_by_label['path_npc']):
            b = path.get_box()
            self.add_baddie(n, b.bottomleft, b.bottomright)

    def add_baddie(self, n, a, b):
        # move baddie from a to b and the gig's up if the player's seen
        print 'ADD', n, a, b
        name = 'npc%d' % n
        a = self.actors[name] = actors.GuardNPC(a, point_a=a, point_b=b,
            direction=1)
        a.change_state('move')
        self.action_layer.add(a.sprite)
        return a

    def trigger_hide1(self):
        self.enable_action('Hide', self.do_hide)
    def untrigger_hide1(self):
        self.disable_action()
    trigger_hide2 = trigger_hide1
    trigger_hide3 = trigger_hide1
    trigger_hide4 = trigger_hide1
    untrigger_hide2 = untrigger_hide1
    untrigger_hide3 = untrigger_hide1
    untrigger_hide4 = untrigger_hide1

    def do_hide(self):
        self.actors['player'].do_hide()
        self.enable_action('Leave hiding', self.do_unhide)

    def do_unhide(self):
        self.actors['player'].do_unhide()
        self.enable_action('Hide', self.do_hide)

    def shoot(self, actor):
        hit = random.random() > .5
        self.add_bullet(actor.sprite.get_rect(), actor.direction,
            self.actors['player'].sprite.get_rect(), hit)
        if hit:
            self.you_died()

    def trigger_back_door(self):
        self.enable_action('Enter Hideout', self.leave)
    def untrigger_back_door(self):
        self.disable_action()

    def leave(self):
        self.new_scene(hideout_sneaking.Scene())

