
import pyglet
from pyglet.window import key
import cocos
from cocos.director import director

class Message(cocos.layer.Layer):
    is_event_handler = True

    def __init__(self, message):
        super(Message, self).__init__()
        w, h = director.get_window_size()
        shade = cocos.layer.ColorLayer(255, 255, 255, 100, w, h)
        self.add(shade, z=1)
        text = cocos.text.Label(message,
            position=(w//2, h//2),
            multiline=True, width=w, height=h,
            anchor_y='center', anchor_x='center',
            font_size=64,# halign='center'
        )
        self.add(text, z=2)

    def on_key_press(self, *args):
        return pyglet.event.EVENT_HANDLED

    def on_key_release(self, symbol, mods):
        if symbol in (key.ESCAPE, key.SPACE):
            director.pop()
        return pyglet.event.EVENT_HANDLED

