
import cocos
from cocos.actions import Delay, CallFunc

from cbl import scene
from cbl import actors
from cbl import apartment_exterior

class Scene(scene.SceneLayer):
    map_file = 'scene_one.svg'

    def open_scene(self):
        # add the player
        self.actors['player'] = actors.Player()
        self.action_layer.add(self.actors['player'])

    def trigger_gender(self):
        pass

    def trigger_partner_entry(self):
        self.triggers_disabled['trigger_partner_entry'] = True
        self.add_actor('partner', actors.Partner, 'target_partner_start')
        self.say('partner', 'Hi J, ...', self.welcome_done)

    def welcome_done(self):
        self.say('partner', "We should probably head to "
            "work - or we could just go out...", duration=5)

    def trigger_keys(self):
        self.enable_action('Pick up keys', self.pick_up_keys)
    def untrigger_keys(self):
        self.disable_action()

    def pick_up_keys(self):
        self.triggers_disabled['trigger_keys'] = True
        self.disable_action()
        self.get_ancestor(cocos.scene.Scene).player_has_keys = True

    def trigger_exit(self):
        self.enable_action('Leave the apartment', self.leave_apartment)
        print self.get_ancestor(cocos.scene.Scene).player_has_keys

    def leave_apartment(self):
        self.new_scene(apartment_exterior.Scene())

